/*
	dispclr.c

	% Display clear.

	 3/24/89  by Ted.
	Extracted from wmgr.c as wmgr_Clear

	OWL 1.1
	Copyright (c) 1988, 1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
*/

#include "oakhead.h"
#include "disppriv.h"

/* -------------------------------------------------------------------------- */

void disp_Clear(color)
	opixval color;
/*
	Clear the whole display flat out, regardless of what windows are present,
	and sending no messages to any windows.
*/
{
	opbox box;
	ptd_struct ptds;

	owl_Assert(disp_Ok(), OE_DC_DISP);

	ptds.win = disp_GetDispWin();
	ptds.emsgdata = NULL;
	ptds.relboxp = &box;
	box.ymin = 0;
	box.xmin = 0;
	box.ymax = disp_GetPixHeight();
	box.xmax = disp_GetPixWidth();

	disp_Cache();
	ptd_Clear(&ptds, color);
	disp_Flush();
}
/* -------------------------------------------------------------------------- */

void disp_Repaint()
{
	owl_Assert(disp_Ok(), OE_DR_DISP);
	wmgr_PaintPixBox(curr_wmgr->bot_sys_win, win_pixboxp(disp_GetDispWin()));
}
/* -------------------------------------------------------------------------- */

