/*
	dispmode.h

	% Operating system independent display-mode definitions.
	  Also includes background window class definitions.

	11/17/88  by Ted.

	OWL 1.1
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 7/05/89 ted	Added def_PmapIoReq macros.
	 7/12/89 ted	Converted '_func' prototypes from typedef to macro.
	 7/18/89 jmd	added stuff for VMS
*/

/* -------------------------------------------------------------------------- */
extern class_func	(cmwin_Class);
extern class_func	(grwin_Class);
extern class_func	(blwin_Class);
extern class_func	(npwin_Class);

#ifdef OAK_DOS
#define def_ModeText		pc_ModeText
#define def_ModeGraphics	pc_ModeGraphics
#define def_ModeCurrent		pc_ModeCurrent

#define def_PmapIoReq		pc_PmapIoReq

extern dmode_func (pc_ModeText);
extern dmode_func (pc_ModeGraphics);
extern dmode_func (pc_ModeCurrent);
extern dmode_func (pc_ModeCurrText);

extern dmode_func (pc_ModeBIOS);
extern dmode_func (pc_ModeBIOS0);
extern dmode_func (pc_ModeBIOS1);
extern dmode_func (pc_ModeBIOS2);
extern dmode_func (pc_ModeBIOS3);
extern dmode_func (pc_ModeBIOSEGA43);
extern dmode_func (pc_ModeBIOSVGA50);
extern dmode_func (pc_ModeBIOS7);

extern dmode_func (pc_ModeHerc);

extern dmode_func (pc_Mode0);
extern dmode_func (pc_Mode1);
extern dmode_func (pc_Mode2);
extern dmode_func (pc_Mode3);
extern dmode_func (pc_ModeEGA43);
extern dmode_func (pc_ModeVGA50);
extern dmode_func (pc_Mode4);
extern dmode_func (pc_Mode5);
extern dmode_func (pc_Mode6);
extern dmode_func (pc_ModeCpq40);
extern dmode_func (pc_Mode7);
extern dmode_func (pc_ModeD);
extern dmode_func (pc_ModeE);
extern dmode_func (pc_ModeF);
extern dmode_func (pc_Mode10);
extern dmode_func (pc_Mode11);
extern dmode_func (pc_Mode12);
extern dmode_func (pc_Mode13);

extern dmode_func (bgi_ModeGraphics);
extern dmode_func (mgr_ModeGraphics);

extern dmode_func (ansi_ModeText);

extern pmapioreq_func (pc_PmapIoReq);
#endif

#ifdef OAK_OS2
#define def_ModeText		os2_ModeText
#define def_ModeCurrent		os2_ModeCurrent

#define def_PmapIoReq		pmap_IoNullReq

extern dmode_func (os2_ModeText);
#endif

#ifdef OAK_APOLLO
#define def_ModeText		gpr_ModeGraphics
#define def_ModeGraphics	gpr_ModeGraphics
#define def_ModeCurrent		gpr_ModeGraphics

#define def_PmapIoReq		pmap_IoNullReq

extern dmode_func (gpr_ModeGraphics);
#endif

#ifdef OAK_UNIX
#define def_ModeText		curs_ModeText
#define def_ModeCurrent		curs_ModeText

#define def_PmapIoReq		pmap_IoNullReq

extern dmode_func (curs_ModeText);
#endif

#ifdef OAK_VMS
#define def_ModeText		smg_ModeText
#define def_ModeCurrent		smg_ModeText

#define def_PmapIoReq		pmap_IoNullReq

extern dmode_func (smg_ModeText);
#endif

/* -------------------------------------------------------------------------- */

