/*
	disprein.c

	% Display manager change-horses-in-midstream swapper.

	8/12/89  by Ted.

	OWL 1.1
	Copyright (c) 1988, 1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
*/
#include "oakhead.h"
#include "disppriv.h"

/* -------------------------------------------------------------------------- */

boolean disp_ReInit(dmode)
	dmode_fptr dmode;		/* Display mode initialization function */
/*
	Change display manager without changing windows or window manager.
*/
{
	boolean mouseon;

	mouseon = hard_IsMouseOn();

	if (mouseon) hard_DeinitMouse();

	/* Close fonts for all windows */

	/* Go back to initial mode so that new dmgr will have correct 'oldmode' */
	disp_RestoreMode();

	/* Close down current DIG */
	disp_CloseDIG();

	/* Initialize a new display manager and DIG. */
	if (!dispsetup(dmode)) {
		return(FALSE);
	}

	/* Restore fonts for all windows */

	win_SetPixSize(disp_GetDispWin(), disp_GetPixWidth(), disp_GetPixHeight());
	disp_Repaint();
	if (mouseon) hard_InitMouse();
	return(TRUE);
}
/* -------------------------------------------------------------------------- */

