/*
	oakdir.h

	% oakland standard file and directory MACROS (MSC5, TURBOC2)

	OWL 1.1
	Copyright (c) 1989, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
*/

#ifdef M5	/*	  	Microsoft C version 5.x Dependent Code 	*/
#	define OAKDIR

#	include <dos.h>
#	include <direct.h>

#	define OFFILE_SDIR		_A_SUBDIR

typedef	struct find_t ofindfile_struct;

#	define oak_findfirst(spec, ofindfilep, a)	_dos_findfirst(spec, a, ofindfilep)
#	define oak_findnext(ofindfilep)			_dos_findnext(ofindfilep)

#	define oak_findfile_attr(ofindfile)		ofindfile.attrib
#	define oak_findfile_name(ofindfile)		ofindfile.name

#	define oak_getcwd(buf, len)			getcwd(buf, len)

#	define oak_remove(file)				remove(file)
#endif

#ifdef TC	/*	  	Turbo C Dependent Code 		*/
#	define OAKDIR

#	include <dos.h>
#	include <dir.h>

#	define OFFILE_SDIR		FA_DIREC

typedef	struct ffblk ofindfile_struct;

#	define oak_findfirst(spec, ofindfilep, a)	findfirst(spec, ofindfilep, a)
#	define oak_findnext(ofindfilep)			findnext(ofindfilep)

#	define oak_findfile_attr(ofindfile)		ofindfile.ff_attrib
#	define oak_findfile_name(ofindfile)		ofindfile.ff_name

#	define oak_getcwd(buf, len)			getcwd(buf, len)

#	define oak_remove(file)				remove(file)
#endif

#ifndef OAKDIR 		/* for those places we haven't fixed yet */

#	define OFFILE_SDIR		0

typedef	struct {
	int dummy;
} ofindfile_struct;

#	define oak_findfirst(spec, ofindfilep, a)	(-1)
#	define oak_findnext(ofindfilep)				(-1)

#	define oak_findfile_attr(ofindfile)		0
#	define oak_findfile_name(ofindfile)		""

#	define oak_getcwd(buf, len)				""

#	define oak_remove(file)

#endif
