/*
	ostdlib.h

	% Oakland stdlib.h version. Depends on what compiler is being used.

	This file depends on a symbol for the Compiler or Operating System
	being #define'd.

	Use one of the following:

	M5
	TC
	LC
	DLC
	OAK_UNIX
	OAK_APOLLO
	OAK_SUN
	OAK_VMS
	OAK_STRATUS
	OAK_DG

	OWL 1.1
	Copyright (c) 1986, 1987, 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 4/07/89 jmd	added math.h for UNIX/APOLLO
	 6/27/89 ted	Removed references to min and max.
	 7/15/89 ted	Added oabs, omin, omax, int_min, int_max for all cases.
*/
/* -------------------------------------------------------------------------- */

#define oabs(a)						(((a) >= 0) ? (a) : -(a))
#define omax(a, b)					(((a) > (b)) ? (a) : (b))
#define omin(a, b)					(((a) < (b)) ? (a) : (b))

extern int int_min(_arg2(int a, int b));
extern int int_max(_arg2(int b, int a));

#ifdef M5	/*	  	Microsoft C version 5.x Dependent Code 	*/
#	include <stdlib.h>
#endif

#ifdef TC	/*	  	Turbo C Dependent Code 		*/
#	include <stdlib.h>
#endif

#ifdef MW	/*	Meta Ware High C Dependent Code	*/
#	include <stdlib.h>
#endif

#ifdef LC	/*	  	Lattice C Dependent Code	*/
#	include <stdlib.h>
#endif

#ifdef OAK_UNIX		/*	  	UNIX Dependent Code */
#	include <math.h>		/* for atof etc. */
#endif

#ifdef OAK_APOLLO
#	include <math.h>		/* for atof etc. */
	VOID *malloc();
	VOID *calloc();
	VOID *realloc();
#endif

#ifdef OAK_SUN		/*	  	SUN Dependent Code */
#endif

#ifdef OAK_VMS		/*	  	VMS Dependent Code */
#endif

#ifdef OAK_STRATUS		/*	  	STRATUS Dependent Code */
#endif

#ifdef OAK_DG	/*	  	Data General C Dependent Code	*/
#endif
/* -------------------------------------------------------------------------- */

