/*
	pcdecl.h

	% declarations for PC display stuff

	5/16/88  by Ted.

	OWL 1.1
	Copyright (c) 1986, 1987, 1988 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/30/88 Ted  	Changed Order of args to ram_memtoseg to extract ram_CopyBox.
	10/07/88 Ted	Obsoleted ram_CopyBox.
	12/05/88 Ted	added mousehides
	12/12/88 ted	Merged CheckKey and CheckMouse into CheckEvent.
	12/13/88 jmd	Messed with dos.h include
	 1/12/89 ted	Separated the pchdata from the pcdata for better sharing.
	 2/04/89 ted	moved ilmasktab into pcdata structure from static data.
	 2/07/89 Ted	added timeout wait arg to hCheckEvent function.
	 2/28/89 ted	extracted pc event related stuff to pchard.h
	 3/19/89 ted	made pcdata static.
	 4/09/89 ted:	pulled static pchdata struct out of pcdata struct.
	 4/26/89 ted	Moved attrmap out of info struct into pcdata.
	 5/09/89 ted	Renamed from pcdisp.h
	 6/17/89 Ted	split pc_bgPlotText into evga_Plot-, mcga_Plot-, pc_bgPlot-.
	 7/05/89 ted	Added fontseg, fontoffs, dispseg for font plotters.
	 7/07/89 ted	Added new font plotting stuff: attrcols, plotchar, etc.
	 7/12/89 ted	Added OSTATIC's and '_func' macros.
	 7/14/89 ted	Removed ilmasktab.
*/

#ifdef LATTICE
#	undef LATTICE		/* Lattice re-defines byte in dos.h, this tells it not to */
#	include <dos.h>	/* has outp for Lattice compiler */
#	define LATTICE
#else
#	ifdef TC
#		include <dos.h>	/* has outp for Turbo compiler */
#	endif
#	ifdef MW
#		define inp(port)				oinp(port)
#		define outp(port,word)			ooutp(port,word)
		/* plinout.asm */
		extern byte oinp(_arg1(short int port));
		extern void ooutp(_arg2(short int port, byte value));
#	endif
#endif
/* -------------------------------------------------------------------------- */
#define attrcols_func(fname)		unsigned DIGPRIV fname(_arg1(byte rattr))
typedef                  unsigned (DIGPRIV *attrcols_fptr)(_arg1(byte rattr));
#define plotchar_func(fname)		void DIGPRIV fname(_arg1(void))
typedef                  void (DIGPRIV *plotchar_fptr)(_arg1(void));

typedef struct {
/* Note: the assembly coded font plotter expects these variables here. */
	unsigned long  fontoffs;		/* offset of current char in font table */
	unsigned short fontseg;			/* segment of font table for current font */
	unsigned short vidaddr;
	unsigned short nsame;			/* the length in chars of the line to plot */
	unsigned short starty;			/* the length in chars of the line to plot */
	unsigned short splitcol;		/* the fg/bg color word */

	unsigned short dispseg;			/* segment at which display memory lies */
	unsigned short ilmask;
	unsigned short ilsize;
	unsigned short vbincr;
	unsigned short fontlines;		/* number of lines in current font */
	byte nplanes;					/* number of bitplanes on display */

	attrcols_fptr  attrcols;		/* swappable attribute tranlation function */
	plotchar_fptr  plotchar;		/* swappable font plotter kernel */

	dispinfo_struct info;
	struct pmap_struct dmspace;		/* pointed to by info->dispmap */
	byte		attrmap[256];		/* attribute map table */
	byte		*xattrmap;			/* ptr to attribute map extension for mcga */
	byte		attrsize;			/* size of attrmap element in bits (there are always 256 of them) */

	int 		oldmode;			/* pre-init video mode to restore from */
	int			oldcursx;			/* pre-init cursor position */
	int			oldcursy;
	cursortype	curctype;			/* current hardware cursor type */

	boolean		retracewait;		/* flag to wait for retrace or not */

	unsigned long fontoffs0;		/* offset of font table for current font */
	unsigned short fontseg0;		/* segment of font table for current font */
	unsigned long fontoffs1;		/* offset of font table for current font */
	unsigned short fontseg1;		/* segment of font table for current font */

	ocolmap_type colmap;			/* Shadow copy of device color map */

	pchdata_struct *h;		/* non-display hardware dig data */
} pcdata_struct;

OEXTERN pcdata_struct pcdatastruc;
#define pcdata 		(&pcdatastruc)
/* -------------------------------------------------------------------------- */

#define ramcopy_func(fname)			void DIGPRIV fname(_arg4(unsigned segm, unsigned segoffs, byte *memaddr, unsigned bwidth))
typedef                   void (DIGPRIV *ramcopy_fptr)(_arg4(unsigned segm, unsigned segoffs, byte *memaddr, unsigned bwidth));

#define ramplanecopy_func(fname)	void DIGPRIV fname(_arg5(unsigned segm, unsigned segoffs, byte *membuf, unsigned bwidth, unsigned memoffs))
typedef              void (DIGPRIV *ramplanecopy_fptr)(_arg5(unsigned segm, unsigned segoffs, byte *membuf, unsigned bwidth, unsigned memoffs));

#define ramclear_func(fname)		void DIGPRIV fname(_arg4(unsigned segm, unsigned segoffs, unsigned bwidth, unsigned short color))
typedef                  void (DIGPRIV *ramclear_fptr)(_arg4(unsigned segm, unsigned segoffs, unsigned bwidth, unsigned short color));

#define rammove_func(fname)			void DIGPRIV fname(_arg4(unsigned segm, unsigned soffs, unsigned doffs, unsigned bwidth))
typedef                   void (DIGPRIV *rammove_fptr)(_arg4(unsigned segm, unsigned soffs, unsigned doffs, unsigned bwidth));

#define pc_setinfo_func(fname)		boolean DIGPRIV fname(_arg1(int))
typedef                boolean (DIGPRIV *pc_setinfo_fptr)(_arg1(int));

/* -------------------------------------------------------------------------- */
/* pcmcurr.c */
extern dmode_func (pc_ModeCurrent);
extern boolean DIGPRIV pc_OpenMode(_arg2(dig_struct *digp, int mode));

/* pcmcurrt.c */
extern dmode_func (pc_ModeCurrText);
extern boolean DIGPRIV pc_OpenModeText(_arg2(dig_struct *digp, int mode));

/* pcmgraph.c */
extern dmode_func (pc_ModeGraphics);

/* pcbios.c */
extern dmode_func (pc_ModeBIOS);
extern dmode_func (pc_ModeBIOS0);
extern dmode_func (pc_ModeBIOS1);
extern dmode_func (pc_ModeBIOS2);
extern dmode_func (pc_ModeBIOS3);
extern dmode_func (pc_ModeBIOSEGA43);
extern dmode_func (pc_ModeBIOSVGA50);
extern dmode_func (pc_ModeBIOS7);

/* pctext.c */
extern dmode_func (pc_ModeText);
extern dmode_func (pc_Mode0);
extern dmode_func (pc_Mode1);
extern dmode_func (pc_Mode2);
extern dmode_func (pc_Mode3);
extern dmode_func (pc_ModeEGA43);
extern dmode_func (pc_ModeVGA50);
extern dmode_func (pc_Mode7);
extern boolean DIGPRIV pc_OpenText(_arg2(dig_struct *, int));

/* pccga.c */
extern dmode_func (pc_Mode4);
extern dmode_func (pc_Mode5);
extern dmode_func (pc_Mode6);
extern dmode_func (pc_ModeCpq40);
extern boolean DIGPRIV pc_OpenCGA(_arg2(dig_struct *, int));

/* pcevga.c */
extern dmode_func (pc_ModeD);
extern dmode_func (pc_ModeE);
extern dmode_func (pc_ModeF);
extern dmode_func (pc_Mode10);
extern dmode_func (pc_Mode11);
extern dmode_func (pc_Mode12);
extern boolean DIGPRIV pc_OpenEVGA(_arg2(dig_struct *, int));

/* pcmcga.c */
extern dmode_func (pc_Mode13);
extern boolean DIGPRIV pc_OpenMCGA(_arg2(dig_struct *, int));

/* pcherc.c */
extern dmode_func (pc_ModeHerc);
extern boolean DIGPRIV pc_OpenHerc(_arg2(dig_struct *, int));

/* pctextin.c */
extern pc_setinfo_func (text_setinfo);

/* pcbscrol.c */
extern dig_pScrollBoxVt_func (text_bScrollBoxVt);

/* pchcfunc.asm */
extern boolean	DIGPRIV herc_present(_arg1(void));
extern int		DIGPRIV herc_getlines(_arg1(void));
extern void		DIGPRIV herc_setgmode(_arg1(int hpage));
extern void		DIGPRIV herc_settmode(_arg1(void));

/* pc1bitpl.asm */
extern plotchar_func (pc_1bitplotchar);

/* pc2bitpl.asm */
extern plotchar_func (pc_2bitplotchar);

/* pc8bitpl.asm */
extern plotchar_func (pc_8bitplotchar);

/* pcevgapl.asm */
extern plotchar_func (pc_evgaplotchar);

/* pchcfont.asm */
OEXTERN unsigned short hercfont_seg;
OEXTERN unsigned long hercfont_offs;	/* Long in case of dos-extender */

/* pcopen.c */
extern boolean DIGPRIV pc_OpenDIG(_arg3(dig_struct *digp, int mode, pc_setinfo_fptr setinfo));
extern dig_CloseDIG_func (pc_CloseDIG);

/* pcdisp.c */
extern dig_dControl_func (pc_dControl);
extern unsigned			pc_dDummy(_arg1(void));
extern unsigned short	DIGPRIV pc_wordcolor(_arg1(opixval color));
extern void				DIGPRIV pc_bgetcursorpos(_arg2(int *rowp, int *colp));
extern void				DIGPRIV pc_initmode(_arg1(void));

/* pcpmap.c */
extern dig_pControl_func (pc_pControl);

/* pcpmapio.c */
extern dig_pControl_func (pc_PmapIoReq);

/* pcgfuncs.c */
extern void DIGPRIV pc_setgfuncs(_arg1(dig_struct *));
extern attrcols_func (pc_attrcols);

/* pcbdrawc.c */
extern dig_pDrawCursor_func (pc_bDrawCursor);

/* pcbsetcu.c */
extern void DIGPRIV pc_bsetcursorpos(_arg2(int row, int col));
extern void DIGPRIV pc_bsetcursortype(_arg2(cursortype ctype, unsigned short nlines));

/* pcrammov.asm */
extern ramclear_func (ram_segwordset);
extern rammove_func (ram_segtoseg);
extern void DIGPRIV ram_mem1toseg(_arg5(unsigned segm, unsigned segoffs, byte *memaddr, unsigned byte1, unsigned blen));
extern ramcopy_func (ram_segtomem);
extern ramcopy_func (ram_memtoseg);

/* pcramwmo.asm */
extern ramclear_func (ram_wsegwordset);
extern rammove_func (ram_wsegtoseg);
extern void DIGPRIV ram_wmem1toseg(_arg5(unsigned segm, unsigned segoffs, byte *memaddr, unsigned byte1, unsigned blen));

/* pcramcle.c */
extern dig_pClear_func (ram_Clear);
extern dig_pScrollBoxVt_func (ram_ScrollBoxVt);
extern dig_pScrollBoxHz_func (ram_ScrollBoxHz);

/* pcramdra.c */
extern dig_pDrawPixmap_func (ram_DrawPixmap);
extern dig_pReadPixmap_func (ram_ReadPixmap);

/* pcramcpp.c */
extern void DIGPRIV ram_copypm(_arg5(opbox *, pmap_type, opcoord, opcoord, ramcopy_fptr));

/* pcsqcmap.c */
extern void DIGPRIV pc_squeezecmap(_arg3(pmap_type pmap, ocolmap_type cmap, ocolmap_type crange));
/* -------------------------------------------------------------------------- */
#define pc_inuse()					(pcdata->info.devname[0] != '\0')

#define pc_attrsize()				(pcdata->attrsize)

#define pc_attrfg4bit(attr)			(pcdata->attrmap[attr] & 0x0F)
#define pc_attrbg4bit(attr)			(pcdata->attrmap[attr] >> 4)

#define pc_attrfgbyte(attr)			pcdata->attrmap[attr]
#define pc_attrbgbyte(attr)			pcdata->xattrmap[attr]

#define pc_initdispmap(wid, hgt)					\
	(pcdata->dmspace.width = (wid), pcdata->dmspace.height = (hgt))
/* -------------------------------------------------------------------------- */
/* DIG - specific pixmap stuff */

typedef struct {
	dispinfo_struct *dispinfo;	/* pointer to dispinfo struct describing */
								/* layout of planes, pixbits, etc. */
	odim	 bytewidth;			/* number of bytes in a line of pixel map. */
	byte	 nshift;			/* number of unused pixels at left of each line */
	byte	 comptype;			/* type of compression applied to pixbuf */
								/*  to accommodate 3rd party image headers */
	byte	*pixbuf;			/* pointer to pixel map memory buffer. */
} pcpmapx_struct;

#define pc_vidseg()					(pcdata->info.dispaddr)
#define pc_bwidth()					(pcdata->info.bytewidth)
#define pc_pixbits()				(pcdata->info.pixbits)
#define pc_nplanes()				(pcdata->info.nplanes)

#define pc_ileave()					(pcdata->info.ileave)
#define pc_ilsize()					(pcdata->info.ilsize)

#define pcpmap_pmapx(pm)			((pcpmapx_struct *) &(pm)[1])
#define pcpmap_planes(pm)			((byte **) &pcpmap_pmapx(pm)[1])

#define pcpmap_dispinfo(pm)			(pcpmap_pmapx(pm)->dispinfo)
#define pcpmap_nplanes(pm)			(pcpmap_pmapx(pm)->dispinfo->nplanes)
#define pcpmap_pixbits(pm)			(pcpmap_pmapx(pm)->dispinfo->pixbits)
#define pcpmap_bytewidth(pm) 		(pcpmap_pmapx(pm)->bytewidth)
#define pcpmap_nshift(pm) 			(pcpmap_pmapx(pm)->nshift)
#define pcpmap_comptype(pm) 		(pcpmap_pmapx(pm)->comptype)
#define pcpmap_pixbuf(pm)			(pcpmap_pmapx(pm)->pixbuf)

#define pcpmap_GetPlaneSize(pmap)					\
	((unsigned long)pcpmap_bytewidth(pmap) * (unsigned long)pmap_GetHeight(pmap))

#define pcpmap_SetDispinfo(pm, di)	(pcpmap_pmapx(pm)->dispinfo = (di))
#define pcpmap_SetBytewidth(pm, bw)	(pcpmap_pmapx(pm)->bytewidth = (bw))
#define pcpmap_SetNshift(pm, ns)	(pcpmap_pmapx(pm)->nshift = (ns))
#define pcpmap_SetComptype(pm, ct)	(pcpmap_pmapx(pm)->comptype = (ct))
#define pcpmap_SetPixbuf(pm, buf)	(pcpmap_pmapx(pm)->pixbuf = (buf))
#define pc_pmheadersize(nplanes)						\
	(sizeof(struct pmap_struct) + sizeof(pcpmapx_struct) +		\
	((((nplanes) <= 1) ? 0 : (nplanes)) * sizeof(byte *)) )

#define pc_retrace()				(pcdata->retracewait)
#define pc_setretrace(rw)			(pcdata->retracewait = (rw))
/* -------------------------------------------------------------------------- */
/* Hardware Equipment Flag Values */
#define PCHFLAG_COLO	0x20
#define PCHFLAG_MONO	0x30

/* -------------------------------------------------------------------------- */
/* BIOS & DOS interrupt definitions */
/* -------------------------------------------------------------------------- */
#define BIOS_VIDINT			0x10
#define VIDINT_SETVM		0x00
#define VIDINT_SETT			0x01
#define VIDINT_SETC			0x02
#define VIDINT_GETC			0x03
#define	VIDINT_SCRLUP		0x06
#define	VIDINT_SCRLDN		0x07
#define	VIDINT_RDCHAR		0x08
#define	VIDINT_WRTCHAR		0x09
#define VIDINT_GETVM		0x0F
#define VIDINT_CHARGEN		0x11
#define CHARGEN_ROM8X8		0x12
#define VIDINT_ALTSEL		0x12
#define ALTSEL_GETINFO		0x10
#define ALTSEL_NEWPRTSCR	0x20
#define ALTSEL_SETLINES		0x30
#define SETLINES_350		0x01
#define SETLINES_400		0x02
#define VIDINT_MODEINFO		0x1B
#define VIDINT_CPQINFO		0xBF

#define CPQINFO_PLASMABIT	0x10

#define BIOS_FONTVEC		0x43
#define BIOS_CGAXFONTVEC	0x1F
#define BIOS_CGAFONTSEG		0xF000
#define BIOS_CGAFONTOFFS	0xFA6E
/* -------------------------------------------------------------------------- */
/* Addresses and counts */

#define TEXT_HEIGHT		25
#define TEXT_XHEIGHT	43
#define TEXT_RPAGE		 0

#define VID_MDAPORT 0x3B4
#define VID_CGAPORT 0x3D4

#define VID_CGAADDR		0xB800
#define VID_MONOADDR	0xB000
#define VID_EVGAADDR	0xA000
#define VID_HERC0ADDR	0xB000
#define VID_HERC1ADDR	0xB800

#define VID_CGABLOCK	0x2000
#define VID_HERCBLOCK	0x2000
/* -------------------------------------------------------------------------- */
/* Default color palette structure initializations */

#ifndef DEFDEFCMAPS

	extern ocolmap_struct(2) pcdefmcmap;
	extern ocolmap_struct(16) pcdefcmap;
	extern ocolmap_struct(256) pcdefmcgamap;

#else

#	define PC_DEF_MCMAPINIT	{ 0, 2, {{0x00, 0x00, 0x00}, {0xFF, 0xFF, 0xFF}} }
#	define PC_DEF_CMAPINIT		{ 0, 16, {			\
		{0x00,0x00,0x00},{0x00,0x00,0xAB},{0x00,0xAB,0x00},{0x00,0xAB,0xAB},	\
		{0xAB,0x00,0x00},{0xAB,0x00,0xAB},{0xAB,0x57,0x00},{0xAB,0xAB,0xAB},	\
		{0x57,0x57,0x57},{0x57,0x57,0xFF},{0x57,0xFF,0x57},{0x57,0xFF,0xFF},	\
		{0xFF,0x57,0x57},{0xFF,0x57,0xFF},{0xFF,0xFF,0x57},{0xFF,0xFF,0xFF}	\
		}}

#	define PC_DEF_MCGAMAPINIT0	{ 0, 256, {			\
		{0x00,0x00,0x00},{0x00,0x00,0xAB},{0x00,0xAB,0x00},{0x00,0xAB,0xAB},	\
		{0xAB,0x00,0x00},{0xAB,0x00,0xAB},{0xAB,0x57,0x00},{0xAB,0xAB,0xAB},	\
		{0x57,0x57,0x57},{0x57,0x57,0xFF},{0x57,0xFF,0x57},{0x57,0xFF,0xFF},	\
		{0xFF,0x57,0x57},{0xFF,0x57,0xFF},{0xFF,0xFF,0x57},{0xFF,0xFF,0xFF},	\
		\
		{0x00,0x00,0x00},{0x17,0x17,0x17},{0x23,0x23,0x23},{0x2F,0x2F,0x2F},	\
		{0x3B,0x3B,0x3B},{0x47,0x47,0x47},{0x53,0x53,0x53},{0x63,0x63,0x63},	\
		{0x73,0x73,0x73},{0x83,0x83,0x83},{0x93,0x93,0x93},{0xA3,0xA3,0xA3},	\
		{0xB3,0xB3,0xB3},{0xCB,0xCB,0xCB},{0xE3,0xE3,0xE3},{0xFF,0xFF,0xFF},
#	define PC_DEF_MCGAMAPINIT2						\
		{0x00,0x00,0xFF},{0x43,0x00,0xFF},{0x7F,0x00,0xFF},{0xBF,0x00,0xFF},	\
		{0xFF,0x00,0xFF},{0xFF,0x00,0xBF},{0xFF,0x00,0x7F},{0xFF,0x00,0x43},	\
		{0xFF,0x00,0x00},{0xFF,0x43,0x00},{0xFF,0x7F,0x00},{0xFF,0xBF,0x00},	\
		{0xFF,0xFF,0x00},{0xBF,0xFF,0x00},{0x7F,0xFF,0x00},{0x43,0xFF,0x00},	\
		\
		{0x00,0xFF,0x00},{0x00,0xFF,0x43},{0x00,0xFF,0x7F},{0x00,0xFF,0xBF},	\
		{0x00,0xFF,0xFF},{0x00,0xBF,0xFF},{0x00,0x7F,0xFF},{0x00,0x43,0xFF},	\
		{0x7F,0x7F,0xFF},{0x9F,0x7F,0xFF},{0xBF,0x7F,0xFF},{0xDF,0x7F,0xFF},	\
		{0xFF,0x7F,0xFF},{0xFF,0x7F,0xDF},{0xFF,0x7F,0xBF},{0xFF,0x7F,0x9F},
#	define PC_DEF_MCGAMAPINIT4						\
		{0xFF,0x7F,0x7F},{0xFF,0x9F,0x7F},{0xFF,0xBF,0x7F},{0xFF,0xDF,0x7F},	\
		{0xFF,0xFF,0x7F},{0xDF,0xFF,0x7F},{0xBF,0xFF,0x7F},{0x9F,0xFF,0x7F},	\
		{0x7F,0xFF,0x7F},{0x7F,0xFF,0x9F},{0x7F,0xFF,0xBF},{0x7F,0xFF,0xDF},	\
		{0x7F,0xFF,0xFF},{0x7F,0xDF,0xFF},{0x7F,0xBF,0xFF},{0x7F,0x9F,0xFF},	\
		\
		{0xB3,0xB3,0xFF},{0xC7,0xB3,0xFF},{0xDB,0xB3,0xFF},{0xEB,0xB3,0xFF},	\
		{0xFF,0xB3,0xFF},{0xFF,0xB3,0xEB},{0xFF,0xB3,0xDB},{0xFF,0xB3,0xC7},	\
		{0xFF,0xB3,0xB3},{0xFF,0xC7,0xB3},{0xFF,0xDB,0xB3},{0xFF,0xEB,0xB3},	\
		{0xFF,0xFF,0xB3},{0xEB,0xFF,0xB3},{0xDB,0xFF,0xB3},{0xC7,0xFF,0xB3},
#	define PC_DEF_MCGAMAPINIT6						\
		{0xB3,0xFF,0xB3},{0xB3,0xFF,0xC7},{0xB3,0xFF,0xDB},{0xB3,0xFF,0xEB},	\
		{0xB3,0xFF,0xFF},{0xB3,0xEB,0xFF},{0xB3,0xDB,0xFF},{0xB3,0xC7,0xFF},	\
		{0x00,0x00,0x73},{0x1F,0x00,0x73},{0x3B,0x00,0x73},{0x57,0x00,0x73},	\
		{0x73,0x00,0x73},{0x73,0x00,0x57},{0x73,0x00,0x3B},{0x73,0x00,0x1F},	\
		\
		{0x73,0x00,0x00},{0x73,0x1F,0x00},{0x73,0x3B,0x00},{0x73,0x57,0x00},	\
		{0x73,0x73,0x00},{0x57,0x73,0x00},{0x3B,0x73,0x00},{0x1F,0x73,0x00},	\
		{0x00,0x73,0x00},{0x00,0x73,0x1F},{0x00,0x73,0x3B},{0x00,0x73,0x57},	\
		{0x00,0x73,0x73},{0x00,0x57,0x73},{0x00,0x3B,0x73},{0x00,0x1F,0x73},
#	define PC_DEF_MCGAMAPINIT8						\
		{0x3B,0x3B,0x73},{0x47,0x3B,0x73},{0x57,0x3B,0x73},{0x63,0x3B,0x73},	\
		{0x73,0x3B,0x73},{0x73,0x3B,0x63},{0x73,0x3B,0x57},{0x73,0x3B,0x47},	\
		{0x73,0x3B,0x3B},{0x73,0x47,0x3B},{0x73,0x57,0x3B},{0x73,0x63,0x3B},	\
		{0x73,0x73,0x3B},{0x63,0x73,0x3B},{0x57,0x73,0x3B},{0x47,0x73,0x3B},	\
		\
		{0x3B,0x73,0x3B},{0x3B,0x73,0x47},{0x3B,0x73,0x57},{0x3B,0x73,0x63},	\
		{0x3B,0x73,0x73},{0x3B,0x63,0x73},{0x3B,0x57,0x73},{0x3B,0x47,0x73},	\
		{0x53,0x53,0x73},{0x5B,0x53,0x73},{0x63,0x53,0x73},{0x6B,0x53,0x73},	\
		{0x73,0x53,0x73},{0x73,0x53,0x6B},{0x73,0x53,0x63},{0x73,0x53,0x5B},
#	define PC_DEF_MCGAMAPINITA						\
		{0x73,0x53,0x53},{0x73,0x5B,0x53},{0x73,0x63,0x53},{0x73,0x6B,0x53},	\
		{0x73,0x73,0x53},{0x6B,0x73,0x53},{0x63,0x73,0x53},{0x5B,0x73,0x53},	\
		{0x53,0x73,0x53},{0x53,0x73,0x5B},{0x53,0x73,0x63},{0x53,0x73,0x6B},	\
		{0x53,0x73,0x73},{0x53,0x6B,0x73},{0x53,0x63,0x73},{0x53,0x5B,0x73},	\
		\
		{0x00,0x00,0x43},{0x13,0x00,0x43},{0x23,0x00,0x43},{0x33,0x00,0x43},	\
		{0x43,0x00,0x43},{0x43,0x00,0x33},{0x43,0x00,0x23},{0x43,0x00,0x13},	\
		{0x43,0x00,0x00},{0x43,0x13,0x00},{0x43,0x23,0x00},{0x43,0x33,0x00},	\
		{0x43,0x43,0x00},{0x33,0x43,0x00},{0x23,0x43,0x00},{0x13,0x43,0x00},
#	define PC_DEF_MCGAMAPINITC						\
		{0x00,0x43,0x00},{0x00,0x43,0x13},{0x00,0x43,0x23},{0x00,0x43,0x33},	\
		{0x00,0x43,0x43},{0x00,0x33,0x43},{0x00,0x23,0x43},{0x00,0x13,0x43},	\
		{0x23,0x23,0x43},{0x2B,0x23,0x43},{0x33,0x23,0x43},{0x3B,0x23,0x43},	\
		{0x43,0x23,0x43},{0x43,0x23,0x3B},{0x43,0x23,0x33},{0x43,0x23,0x2B},	\
		\
		{0x43,0x23,0x23},{0x43,0x2B,0x23},{0x43,0x33,0x23},{0x43,0x3B,0x23},	\
		{0x43,0x43,0x23},{0x3B,0x43,0x23},{0x33,0x43,0x23},{0x2B,0x43,0x23},	\
		{0x23,0x43,0x23},{0x23,0x43,0x2B},{0x23,0x43,0x33},{0x23,0x43,0x3B},	\
		{0x23,0x43,0x43},{0x23,0x3B,0x43},{0x23,0x33,0x43},{0x23,0x2B,0x43},
#	define PC_DEF_MCGAMAPINITE						\
		{0x2F,0x2F,0x43},{0x33,0x2F,0x43},{0x37,0x2F,0x43},{0x3F,0x2F,0x43},	\
		{0x43,0x2F,0x43},{0x43,0x2F,0x3F},{0x43,0x2F,0x37},{0x43,0x2F,0x33},	\
		{0x43,0x2F,0x2F},{0x43,0x33,0x2F},{0x43,0x37,0x2F},{0x43,0x3F,0x2F},	\
		{0x43,0x43,0x2F},{0x3F,0x43,0x2F},{0x37,0x43,0x2F},{0x33,0x43,0x2F},	\
		\
		{0x2F,0x43,0x2F},{0x2F,0x43,0x33},{0x2F,0x43,0x37},{0x2F,0x43,0x3F},	\
		{0x2F,0x43,0x43},{0x2F,0x3F,0x43},{0x2F,0x37,0x43},{0x2F,0x33,0x43},	\
		{0x3F,0x3F,0x3F},{0x3F,0x3F,0x3F},{0x3F,0x3F,0x3F},{0x3F,0x3F,0x3F},	\
		{0x3F,0x3F,0x3F},{0x3F,0x3F,0x3F},{0x3F,0x3F,0x3F},{0x7F,0x7F,0x7F}		\
		}}
#endif
/* -------------------------------------------------------------------------- */

