/*
	pcramdra.c

	% PC device interface RAM drawing routines

	2/04/89  by Ted.

	OWL 1.1
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 2/04/89 Ted	Removed retrace from Read/Draw Pixmap because no text mode.
*/

#include "pcpriv.h"

/* -------------------------------------------------------------------------- */

void ram_DrawPixmap(ptd, pmap, pmboxp)
	ptd_struct *ptd;
	pmap_type pmap;
	opbox *pmboxp;
/*
	Copy from the portion of pixmap that is inside 'pmboxp' to the
	display inside of 'ptd->relboxp'.
*/
{
	opbox scrbox;
	opcoord pmx, pmy;

	if (copypm_clip(ptd, pmap, pmboxp, &scrbox, &pmx, &pmy)) {
		ram_copypm(&scrbox, pmap, pmx, pmy, ram_memtoseg);
	}
}
/* -------------------------------------------------------------------------- */

void ram_ReadPixmap(ptd, pmap, pmboxp)
	ptd_struct *ptd;
	pmap_type pmap;
	opbox *pmboxp;
/*
	Copy into the portion of pixmap that is inside 'pmboxp' from the
	display inside of 'ptd->relboxp'.
*/
{
	opbox scrbox;
	opcoord pmx, pmy;

	if (copypm_clip(ptd, pmap, pmboxp, &scrbox, &pmx, &pmy)) {
		ram_copypm(&scrbox, pmap, pmx, pmy, ram_segtomem);
	}
}
/* -------------------------------------------------------------------------- */

