/*
	pcxdecl.h

	% declarations for PCX image i/o.

	5/02/89  by Ted.

	OWL 1.1
	Copyright (c) 1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
*/
#define PCX_FILLER	56

typedef struct {
	byte mfgr;
	byte version;
	byte encoding;
	byte pixbits;
	unsigned short xmin;
	unsigned short ymin;
	unsigned short xmax;
	unsigned short ymax;

	unsigned short hres;
	unsigned short vres;

	byte rgb[16][3];
	byte reserved;
	byte nplanes;
	unsigned short linebytes;
	unsigned short paltype;		/* 1 := color/bw, 2:= greyscale */
	unsigned short ylines;
	byte filler[PCX_FILLER];
} pcxhdr_struct;

#define pcxunpack_func(fname)		boolean DIGPRIV fname(_arg3(struct frw_struct *frw, pcxhdr_struct *pcxhdr, pmap_type pmap))
typedef                 boolean (DIGPRIV *pcxunpack_fptr)(_arg3(struct frw_struct *frw, pcxhdr_struct *pcxhdr, pmap_type pmap));

#define pcxpack_func(fname)			boolean DIGPRIV fname(_arg2(struct frw_struct *frw, pmap_type pmap))
typedef                   boolean (DIGPRIV *pcxpack_fptr)(_arg2(struct frw_struct *frw, pmap_type pmap));
/* -------------------------------------------------------------------------- */

/* pcxload.c */
extern void DIGPRIV dig_loadpcx(_arg4(frw_type frw, pmap_type *pmapp, ocolmap_type *cmapp, pcxunpack_fptr unpackpcx));
extern boolean DIGPRIV pcx_readline(_arg4(frw_type frw, byte *obuf, unsigned linebytes, unsigned *ocountp));
extern void DIGPRIV pcx_hdrflip(_arg1(pcxhdr_struct *pcxhdr));

/* pcxsave.c */
extern boolean DIGPRIV dig_savepcx(_arg4(frw_type frw, pmap_type pmap, ocolmap_type cmap, pcxpack_fptr packpcx));
extern boolean DIGPRIV pcx_writeline(_arg3(frw_type frw, byte *obuf, unsigned linebytes));
/* -------------------------------------------------------------------------- */

