/*
	symldecl.h

	% symbol list header

	OWL 1.1
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/09/89 jdc	changed oslist_GetSym to oslist_Get
*/

typedef	struct oslist_struct {

	xarray	seqnt;
	int 	count;

	iarray	alpha;
	int 	size;

	int 	dsize;		/* size of data element associated with each symbol */

} *oslist_type;

#define	OSLIST_SYMMAXLEN	100
#define	OSLIST_BADNAME		-1

extern oslist_type	oslist_Open(_arg2(int, int));
extern int			_oslist_put(_arg3(oslist_type, char*, VOID *));
extern char *	 	oslist_Get(_arg2(oslist_type, int));
extern void 		oslist_SetData(_arg3(oslist_type, int, VOID*));
extern int		 	oslist_AlphaHandle(_arg2(oslist_type, int));
extern int			oslist_FindSymHandle(_arg2(oslist_type, char*));
extern int			oslist_DelSym(_arg2(oslist_type, int));
extern void 		oslist_Close(_arg1(oslist_type));
extern int			oslist_GetSize(_arg1(oslist_type));

#define	oslist_Put(l, s, d)			_oslist_put(l, s, (VOID *)d)
#define oslist_GetAlpha(oslist, a)	oslist_Get(oslist, oslist_AlphaHandle(oslist, a))

#define oslist_GetDataSize(oslist)	( oslist->dsize )
#define sym_GetData(sym)		( (sym == NULL) ? (char *) NULL : sym + strlen(sym) + 1 )

