#---------------------------------------------------------------
#
# Oakland OWL library makefile for use with Turbo-C 2.0 Make
#
# 09/11/89 	Created				JSM
#
#---------------------------------------------------------------


# Set the Memory Model

MODEL		= l
#MODEL		= m

# Other defines
COMPILER	= T2
TARG 		= $(COMP)$(MODEL)owl.lib

# Dependency Information

OWLFILES	= bbchain.obj bcwin.obj bd1.obj bd123.obj bd2.obj bdbar.obj \
		  bdbox.obj bdboxlt.obj bdhead.obj bdmouse.obj bdnull.obj bdplain.obj \
		  bdprompt.obj bdside.obj bdstd.obj bdtitle.obj bdxref.obj \
		  bfaux.obj bfile.obj blwin.obj bobgo.obj bobset.obj bordaux.obj \
		  bordclos.obj borddrwt.obj bordghzb.obj bordglts.obj \
		  bordgvtb.obj bordimo.obj bordobj.obj bordout.obj \
		  bordsend.obj bordsetp.obj bordssds.obj cmap.obj \
		  cmapput.obj cmwin.obj cmwindra.obj cmwinimo.obj \
		  cmwintty.obj disp.obj dispclr.obj dispcurr.obj \
		  dispinit.obj dispmono.obj disprein.obj expbmu.obj \
		  expstd.obj frw.obj grwin.obj jains.obj jarray.obj \
		  kbidle.obj kbread.obj kbrecord.obj mouseini.obj msgwin.obj \
		  npwin.obj oakalloc.obj oakerrno.obj oakerror.obj \
		  oakint.obj objfuncs.obj oboxclip.obj oboxdist.obj \
		  ocbox.obj ocolmap.obj omemmove.obj opbox.obj opclipso.obj \
		  opclipst.obj pmapload.obj pmapopen.obj pmapx.obj pmwin.obj \
		  pmwinimo.obj pmwinope.obj ptdchar.obj ptdframe.obj \
		  ptdline.obj sarray.obj strtools.obj strwrap.obj \
		  symlist.obj varray.obj vid.obj winclear.obj winclip.obj \
		  wincurso.obj windump.obj winexpos.obj wingetp.obj \
		  wingo.obj winlist.obj winload.obj winmouse.obj \
		  winobj.obj winobsc.obj winopen.obj winpaint.obj \
		  winsave.obj winscrol.obj winsetp.obj winsize.obj \
		  wintop.obj wmgrinit.obj

DIGFILES	= digcursb.obj digcursl.obj digflip.obj digpmcli.obj \
		  digpow2.obj digscmap.obj digshsec.obj pcxload.obj pcxsave.obj

PCFILES 	= pcbdrawc.obj pcbios.obj pcbscrol.obj pcbsetcu.obj \
		  pccga.obj pcdisp.obj pcevga.obj pcgfuncs.obj pchard.obj \
		  pcherc.obj pcmcga.obj pcmcurr.obj pcmcurrt.obj \
		  pcmgraph.obj pcmode.obj pcopen.obj pcpmap.obj pcpmapio.obj \
		  pcramcle.obj pcramcpp.obj pcramdra.obj pcrestor.obj \
		  pcsplash.obj pcsqcmap.obj pctext.obj pctextin.obj pcvgrab.obj

PCAFILES	= pc1bitpl.obj pc2bitpl.obj pc8bitpl.obj pcbunrun.obj \
		  pcbxlat.obj pcevgapl.obj pchcfont.obj pchcfunc.obj \
		  pciscpq.obj pcneares.obj pcoint86.obj pcrammov.obj \
		  pcramwmo.obj pcvfreez.obj pcvscan.obj

# Library Creation 

FILES	= $(OWLFILES) $(DIGFILES) $(PCFILES) $(PCAFILES)

$(TARG) : $(FILES)
	tlib $(COMP)$(MODEL)owl.lib /C /E /0 @t2owl.rsp


#---------------------------------------------------------------

bbchain.obj: bbchain.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bbchain.c
 
bcwin.obj: bcwin.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bcwin.c
 
bd1.obj: bd1.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bd1.c
 
bd123.obj: bd123.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bd123.c
 
bd2.obj: bd2.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bd2.c
 
bdbar.obj: bdbar.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bdbar.c
 
bdbox.obj: bdbox.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bdbox.c
 
bdboxlt.obj: bdboxlt.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bdboxlt.c

bdhead.obj: bdhead.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bdhead.c
 
bdmouse.obj: bdmouse.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bdmouse.c
 
bdnull.obj: bdnull.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bdnull.c
 
bdplain.obj: bdplain.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bdplain.c
 
bdprompt.obj: bdprompt.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bdprompt.c
 
bdside.obj: bdside.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bdside.c
 
bdstd.obj: bdstd.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bdstd.c
 
bdtitle.obj: bdtitle.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bdtitle.c
 
bdxref.obj: bdxref.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bdxref.c
 
bfaux.obj: bfaux.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bfaux.c
 
bfile.obj: bfile.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bfile.c
 
blwin.obj: blwin.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT blwin.c
 
bobgo.obj: bobgo.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bobgo.c

bobset.obj: bobset.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bobset.c
 
bordaux.obj: bordaux.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bordaux.c
 
bordclos.obj: bordclos.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bordclos.c
 
borddrwt.obj: borddrwt.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT borddrwt.c
 
bordghzb.obj: bordghzb.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bordghzb.c
 
bordglts.obj: bordglts.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bordglts.c

bordgvtb.obj: bordgvtb.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bordgvtb.c
 
bordimo.obj: bordimo.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bordimo.c
 
bordobj.obj: bordobj.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bordobj.c
 
bordout.obj: bordout.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bordout.c
 
bordsend.obj: bordsend.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bordsend.c
 
bordsetp.obj: bordsetp.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bordsetp.c
 
bordssds.obj: bordssds.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT bordssds.c
 
cmap.obj: cmap.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT cmap.c
 
cmapput.obj: cmapput.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT cmapput.c
 
cmwin.obj: cmwin.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT cmwin.c
 
cmwindra.obj: cmwindra.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT cmwindra.c
 
cmwinimo.obj: cmwinimo.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT cmwinimo.c
 
cmwintty.obj: cmwintty.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT cmwintty.c
 
disp.obj: disp.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT disp.c
 
dispclr.obj: dispclr.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT dispclr.c
 
dispcurr.obj: dispcurr.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT dispcurr.c
 
dispinit.obj: dispinit.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT dispinit.c
 
dispmono.obj: dispmono.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT dispmono.c
 
disprein.obj: disprein.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT disprein.c
 
expbmu.obj: expbmu.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT expbmu.c
 
expstd.obj: expstd.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT expstd.c
 
frw.obj: frw.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT frw.c
 
grwin.obj: grwin.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT grwin.c
 
jains.obj: jains.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT jains.c
 
jarray.obj: jarray.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT jarray.c
 
kbidle.obj: kbidle.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT kbidle.c
 
kbread.obj: kbread.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT kbread.c
 
kbrecord.obj: kbrecord.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT kbrecord.c
 
mouseini.obj: mouseini.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT mouseini.c
 
msgwin.obj: msgwin.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT msgwin.c
 
npwin.obj: npwin.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT npwin.c
 
oakalloc.obj: oakalloc.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT oakalloc.c
 
oakerrno.obj: oakerrno.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT oakerrno.c
 
oakerror.obj: oakerror.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT oakerror.c
 
oakint.obj: oakint.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT oakint.c
 
objfuncs.obj: objfuncs.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT objfuncs.c
 
oboxclip.obj: oboxclip.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT oboxclip.c
 
oboxdist.obj: oboxdist.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT oboxdist.c
 
ocbox.obj: ocbox.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT ocbox.c
 
ocolmap.obj: ocolmap.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT ocolmap.c
 
omemmove.obj: omemmove.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT omemmove.c
 
opbox.obj: opbox.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT opbox.c
 
opclipso.obj: opclipso.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT opclipso.c
 
opclipst.obj: opclipst.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT opclipst.c
 
pmapload.obj: pmapload.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pmapload.c
 
pmapopen.obj: pmapopen.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pmapopen.c
 
pmapx.obj: pmapx.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pmapx.c
 
pmwin.obj: pmwin.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pmwin.c
 
pmwinimo.obj: pmwinimo.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pmwinimo.c
 
pmwinope.obj: pmwinope.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pmwinope.c
 
ptdchar.obj: ptdchar.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT ptdchar.c
 
ptdframe.obj: ptdframe.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT ptdframe.c
 
ptdline.obj: ptdline.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT ptdline.c
 
sarray.obj: sarray.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT sarray.c
 
strtools.obj: strtools.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT strtools.c
 
strwrap.obj: strwrap.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT strwrap.c
 
symlist.obj: symlist.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT symlist.c
 
varray.obj: varray.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT varray.c
 
vid.obj: vid.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT vid.c
 
winclear.obj: winclear.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT winclear.c
 
winclip.obj: winclip.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT winclip.c
 
wincurso.obj: wincurso.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT wincurso.c
 
windump.obj: windump.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT windump.c
 
winexpos.obj: winexpos.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT winexpos.c
 
wingetp.obj: wingetp.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT wingetp.c
 
wingo.obj: wingo.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT wingo.c
 
winlist.obj: winlist.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT winlist.c
 
winload.obj: winload.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT winload.c
 
winmouse.obj: winmouse.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT winmouse.c
 
winobj.obj: winobj.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT winobj.c
 
winobsc.obj: winobsc.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT winobsc.c
 
winopen.obj: winopen.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT winopen.c
 
winpaint.obj: winpaint.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT winpaint.c
 
winsave.obj: winsave.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT winsave.c
 
winscrol.obj: winscrol.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT winscrol.c
 
winsetp.obj: winsetp.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT winsetp.c
 
winsize.obj: winsize.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT winsize.c
 
wintop.obj: wintop.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT wintop.c
 
wmgrinit.obj: wmgrinit.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT wmgrinit.c

# DIG compile lines

digcursb.obj: digcursb.c
	tcc -m$(MODEL) -I. -zCPCDIG_TEXT digcursb.c

digcursl.obj: digcursl.c
	tcc -m$(MODEL) -I. -zCPCDIG_TEXT digcursl.c
 
digflip.obj: digflip.c
	tcc -m$(MODEL) -I. -zCPCDIG_TEXT digflip.c
 
digpmcli.obj: digpmcli.c
	tcc -m$(MODEL) -I. -zCPCDIG_TEXT digpmcli.c

digpow2.obj: digpow2.c
	tcc -m$(MODEL) -I. -zCPCDIG_TEXT digpow2.c
 
digscmap.obj: digscmap.c
	tcc -m$(MODEL) -I. -zCPCDIG_TEXT digscmap.c
 
digshsec.obj: digshsec.c
	tcc -m$(MODEL) -I. -zCPCDIG_TEXT digshsec.c
 
pcxload.obj: pcxload.c
	tcc -m$(MODEL) -I. -zCPCDIG_TEXT pcxload.c
 
pcxsave.obj: pcxsave.c
	tcc -m$(MODEL) -I. -zCPCDIG_TEXT pcxsave.c

# PC Files

pcbdrawc.obj: pcbdrawc.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcbdrawc.c

pcbios.obj: pcbios.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcbios.c
 
pcbscrol.obj: pcbscrol.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcbscrol.c
 
pcbsetcu.obj: pcbsetcu.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcbsetcu.c

pccga.obj: pccga.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pccga.c
 
pcdisp.obj: pcdisp.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcdisp.c
 
pcevga.obj: pcevga.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcevga.c
 
pcgfuncs.obj: pcgfuncs.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcgfuncs.c
 
pchard.obj: pchard.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pchard.c

pcherc.obj: pcherc.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcherc.c
 
pcmcga.obj: pcmcga.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcmcga.c
 
pcmcurr.obj: pcmcurr.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcmcurr.c
 
pcmcurrt.obj: pcmcurrt.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcmcurrt.c

pcmgraph.obj: pcmgraph.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcmgraph.c
 
pcmode.obj: pcmode.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcmode.c
 
pcopen.obj: pcopen.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcopen.c
 
pcpmap.obj: pcpmap.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcpmap.c
 
pcpmapio.obj: pcpmapio.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcpmapio.c
   
pcramcle.obj: pcramcle.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcramcle.c
 
pcramcpp.obj: pcramcpp.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcramcpp.c
 
pcramdra.obj: pcramdra.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcramdra.c
 
pcrestor.obj: pcrestor.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcrestor.c

pcsplash.obj: pcsplash.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcsplash.c
 
pcsqcmap.obj: pcsqcmap.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcsqcmap.c
 
pctext.obj: pctext.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pctext.c
 
pctextin.obj: pctextin.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pctextin.c
 
pcvgrab.obj: pcvgrab.c
	tcc -m$(MODEL) -I. -zCOWL_TEXT pcvgrab.c

# PCA ( Assembler)

pc1bitpl.obj: pc1bitpl.asm
	tasm /ml /d$(COMPILER)=99 /d$(MODEL)MOD=99 /dDIGSEG=99 pc1bitpl.asm , ;
 
pc2bitpl.obj: pc2bitpl.asm
	tasm /ml /d$(COMPILER)=99 /d$(MODEL)MOD=99 /dDIGSEG=99 pc2bitpl.asm , ;
 
pc8bitpl.obj: pc8bitpl.asm
	tasm /ml /d$(COMPILER)=99 /d$(MODEL)MOD=99 /dDIGSEG=99 pc8bitpl.asm , ;
 
pcbunrun.obj: pcbunrun.asm
	tasm /ml /d$(COMPILER)=99 /d$(MODEL)MOD=99 /dDIGSEG=99 pcbunrun.asm , ;
 
pcbxlat.obj: pcbxlat.asm
	tasm /ml /d$(COMPILER)=99 /d$(MODEL)MOD=99 /dDIGSEG=99 pcbxlat.asm , ;
 
pcevgapl.obj: pcevgapl.asm
	tasm /ml /d$(COMPILER)=99 /d$(MODEL)MOD=99 /dDIGSEG=99 pcevgapl.asm , ;
 
pchcfont.obj: pchcfont.asm
	tasm /ml /d$(COMPILER)=99 /d$(MODEL)MOD=99 /dDIGSEG=99 pchcfont.asm , ;
 
pchcfunc.obj: pchcfunc.asm
	tasm /ml /d$(COMPILER)=99 /d$(MODEL)MOD=99 /dDIGSEG=99 pchcfunc.asm , ;
 
pciscpq.obj: pciscpq.asm
	tasm /ml /d$(COMPILER)=99 /d$(MODEL)MOD=99 /dDIGSEG=99 pciscpq.asm , ;
 
pcneares.obj: pcneares.asm
	tasm /ml /d$(COMPILER)=99 /d$(MODEL)MOD=99 /dDIGSEG=99 pcneares.asm , ;
 
pcoint86.obj: pcoint86.asm
	tasm /ml /d$(COMPILER)=99 /d$(MODEL)MOD=99 /dDIGSEG=99 pcoint86.asm , ;
 
pcrammov.obj: pcrammov.asm
	tasm /ml /d$(COMPILER)=99 /d$(MODEL)MOD=99 /dDIGSEG=99 pcrammov.asm , ;
 
pcramwmo.obj: pcramwmo.asm
	tasm /ml /d$(COMPILER)=99 /d$(MODEL)MOD=99 /dDIGSEG=99 pcramwmo.asm , ;
 
pcvfreez.obj: pcvfreez.asm
	tasm /ml /d$(COMPILER)=99 /d$(MODEL)MOD=99 /dDIGSEG=99 pcvfreez.asm , ;
 
pcvscan.obj: pcvscan.asm
	tasm /ml /d$(COMPILER)=99 /d$(MODEL)MOD=99 /dDIGSEG=99 pcvscan.asm , ;


# EOF
