/*
	winod.h	6/18/88

	% Window object definitions for basic window types

	OWL 1.1
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/09/88 jmd	revised to use new object stuff
	11/20/88 jmd	Window tags are now in oakalloc.h (and have new names)

	 8/11/89 jmd	Added new bob class
*/

#ifndef OAK_WINOD
#define OAK_WINOD

#include "commonod.h"
/* -------------------------------------------------------------------------- */
/* The bob class */

typedef struct {
	common_od	cd;				/* the common object superclass od */

} bob_od;

/* bob_DoRaw macros to nothing for now */
#define bob_DoRaw(winobj, msg, indata, outdata) 	(TRUE)

#define bobod_GetSelf(wdd)			(commonod_GetSelf(&(wdd)->cd))

/* The window class */

typedef struct {
	bob_od		cd;				/* the bob object superclass od */
	boolean		current;		/* flag for whether this is the current, cursor-showing window */
	unsigned 	curshide;		/* hide/show count for cursor in this window */

	pmap_type 	cursunder;		/* graphics cursor under buffer */
	boolean		cudrawn;		/* graphics cursor drawn flag */
	opbox 		cubox;			/* graphics cursor under-buffer location */
} win_od;

#define win_DoRaw(winobj, msg, indata, outdata) 	\
	obj_DoRaw(win_Class, winobj, msg, indata, outdata)

#define winod_GetSelf(wdd)			((win_type) bobod_GetSelf(&(wdd)->cd))

/* -------------------------------------------------------------------------- */
/* The no_paint window class */

typedef struct {
	win_od	wd;		  		/* window super class */
} npwin_od;

#define npwin_DoRaw(npwinobj, msg, indata, outdata) 	\
	obj_DoRaw(npwin_Class, npwinobj, msg, indata, outdata)

#define npwinod_GetSelf(npwdd)		(winod_GetSelf(&(npwdd)->wd))
/* -------------------------------------------------------------------------- */
/* The blank window class */

typedef struct {
	win_od	wd;		  		/* window super class */
} blwin_od;

#define blwin_DoRaw(blwinobj, msg, indata, outdata) 	\
	obj_DoRaw(blwin_Class, blwinobj, msg, indata, outdata)

#define blwinod_GetSelf(blwdd)		(winod_GetSelf(&(blwdd)->wd))
/* -------------------------------------------------------------------------- */
/* Request funcs */

OEXTERN objreq_fptr winreq_loadfptr;
OEXTERN objreq_fptr winreq_savefptr;

#endif

