/*
	winsfile.h

	% window sfile header (public stuff)

	OWL 1.1
	Copyright (c) 1986-1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	---------------------
	 8/11/89 jdc	split from sfile.h
*/

#include "bfdecl.h"


#define FSYM_NULLSTR				""
#define	fsym_NullCheck(name)		(((name) == NULL) ? FSYM_NULLSTR : (name))

#define ID_LNFWIN		801

#define SFILE_BSIZE 	500
#define SFILE_BUFLEN	1000
#define	SFILE_COMMENT	"CSVER 3.1"

typedef struct sfile_struct {
	
	bfile_type 		bfile;
	oslist_type		oslist_array[TOT_FSYM_COUNT];
	unsigned int	oslist_owner:1;
	unsigned int	alloc:1;	/* for sed data allocation */

	char			buf[SFILE_BUFLEN + 1];

} *sfile_type;

extern sfile_type	_sfile_open(_arg4(char *, fsyminit_struct *, oslist_type *, char *));
extern void			sfile_Close(_arg1(sfile_type));

extern obj_type		sfile_LoadObj(_arg2(sfile_type, char*));
extern boolean		sfile_SaveObj(_arg3(sfile_type, obj_type, char*));

extern obj_type		sf_loadobj(_arg1(sfile_type));
extern boolean		sf_saveobj(_arg2(sfile_type, obj_type));

extern char *		strnewlclip(_arg1(char *));

extern boolean		sfile_SaveComment(_arg2(sfile_type, char*));

#define sfile_Open(name, fsyminit)	_sfile_open(name, fsyminit, NULL, SFILE_COMMENT)

#define sfile_LoadComment(sf, b, blen)	_bfile_gets(sf->bfile, b, blen, '\0')

#define sfile_Find(sf, name, type)	bfile_Find((sf)->bfile, name, type)
#define sfile_GetDirList(sf)		((sf)->bfile->dir)
